# On the Discoverability of npm Vulnerabilities in Node.js Projects

To facilitate the reproduction and foment further research in the field, we provide a replication package containing the artifacts used to conduct our study approach to identify and classify npm vulnerable packages in a Node.js Github project.


## Package structure:

To better understand the package, we briefly describe the structure of our package:

- `Step1`: Implements Step 1 in our approach (Section 5); which extracts the dependency list. The output of this step is the dependency list used in each project through the project lifetime.

- `Step2`: Implement Step 2 in our approach (Section 5), which identifies the vulnerable dependency versions.

- `Step3`:  Implements Step 3 in our approach (Section 5), which classifies each dependency vulnerability according to our defined discoverability levels.


## Instructions to run the package:

- `Requirements`: Install Python (version >= 3), install Git (version >= 2), install Node (version >= 8). The scripts will likely work out of the box on any Linux-like and Mac platforms upon providing the right requirements and versions.

-  `Tokens`: Insert some Github tokens in the array list defined in row 38, file: `Step1/extract_deps.py`; you may need more than one token to run for the complete list of repos.

- Execute `analyze.py`: This script is a pipeline that calls all the three steps above. 

- The final output will be saved in `Step3/OUTPUT`. The output contains CSV files, one for each analyzed project. The CSV file contains the analysis of discoverability levels for the project and metadata related to the analyzed packages.
 
